Package com.google.protobuf

# Class DescriptorProtos.FieldDescriptorProto.Builder

java.lang.Object
com.google.protobuf.AbstractMessageLite.Builder
com.google.protobuf.AbstractMessage.Builder<DescriptorProtos.FieldDescriptorProto.Builder>
com.google.protobuf.GeneratedMessage.Builder<DescriptorProtos.FieldDescriptorProto.Builder>
com.google.protobuf.DescriptorProtos.FieldDescriptorProto.Builder

All Implemented Interfaces:
  `DescriptorProtos.FieldDescriptorProtoOrBuilder`, `Message.Builder`, `MessageLite.Builder`, `MessageLiteOrBuilder`, `MessageOrBuilder`, `Cloneable`

Enclosing class:
  `DescriptorProtos.FieldDescriptorProto`

public static final class DescriptorProtos.FieldDescriptorProto.Builder extends GeneratedMessage.Builder<DescriptorProtos.FieldDescriptorProto.Builder> implements DescriptorProtos.FieldDescriptorProtoOrBuilder
Protobuf type `google.protobuf.FieldDescriptorProto`

## Method Summary

Modifier and Type
Method
Description
`DescriptorProtos.FieldDescriptorProto`
`build()`
Constructs the message based on the state of the Builder.
`DescriptorProtos.FieldDescriptorProto`
`buildPartial()`
Like `MessageLite.Builder.build()`, but does not throw an exception if the message is missing required fields.
`DescriptorProtos.FieldDescriptorProto.Builder`
`clear()`
Called by the initialization and clear code paths to allow subclasses to reset any of their builtin fields back to the initial values.
`DescriptorProtos.FieldDescriptorProto.Builder`
`clearDefaultValue()`
`optional string default_value = 7 [json_name = "defaultValue"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`clearExtendee()`
`optional string extendee = 2 [json_name = "extendee"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`clearJsonName()`
`optional string json_name = 10 [json_name = "jsonName"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`clearLabel()`
`optional .google.protobuf.FieldDescriptorProto.Label label = 4 [json_name = "label"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`clearName()`
`optional string name = 1 [json_name = "name"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`clearNumber()`
`optional int32 number = 3 [json_name = "number"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`clearOneofIndex()`
`optional int32 oneof_index = 9 [json_name = "oneofIndex"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`clearOptions()`
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`clearProto3Optional()`
`optional bool proto3_optional = 17 [json_name = "proto3Optional"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`clearType()`
`optional .google.protobuf.FieldDescriptorProto.Type type = 5 [json_name = "type"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`clearTypeName()`
`optional string type_name = 6 [json_name = "typeName"];`
`DescriptorProtos.FieldDescriptorProto`
`getDefaultInstanceForType()`
Get an instance of the type with no fields set.
`String`
`getDefaultValue()`
`optional string default_value = 7 [json_name = "defaultValue"];`
`ByteString`
`getDefaultValueBytes()`
`optional string default_value = 7 [json_name = "defaultValue"];`
`static final Descriptors.Descriptor`
`getDescriptor()`
`Descriptors.Descriptor`
`getDescriptorForType()`
Get the message's type's descriptor.
`String`
`getExtendee()`
`optional string extendee = 2 [json_name = "extendee"];`
`ByteString`
`getExtendeeBytes()`
`optional string extendee = 2 [json_name = "extendee"];`
`String`
`getJsonName()`
`optional string json_name = 10 [json_name = "jsonName"];`
`ByteString`
`getJsonNameBytes()`
`optional string json_name = 10 [json_name = "jsonName"];`
`DescriptorProtos.FieldDescriptorProto.Label`
`getLabel()`
`optional .google.protobuf.FieldDescriptorProto.Label label = 4 [json_name = "label"];`
`String`
`getName()`
`optional string name = 1 [json_name = "name"];`
`ByteString`
`getNameBytes()`
`optional string name = 1 [json_name = "name"];`
`int`
`getNumber()`
`optional int32 number = 3 [json_name = "number"];`
`int`
`getOneofIndex()`
`optional int32 oneof_index = 9 [json_name = "oneofIndex"];`
`DescriptorProtos.FieldOptions`
`getOptions()`
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`
`DescriptorProtos.FieldOptions.Builder`
`getOptionsBuilder()`
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`
`DescriptorProtos.FieldOptionsOrBuilder`
`getOptionsOrBuilder()`
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`
`boolean`
`getProto3Optional()`
`optional bool proto3_optional = 17 [json_name = "proto3Optional"];`
`DescriptorProtos.FieldDescriptorProto.Type`
`getType()`
`optional .google.protobuf.FieldDescriptorProto.Type type = 5 [json_name = "type"];`
`String`
`getTypeName()`
`optional string type_name = 6 [json_name = "typeName"];`
`ByteString`
`getTypeNameBytes()`
`optional string type_name = 6 [json_name = "typeName"];`
`boolean`
`hasDefaultValue()`
`optional string default_value = 7 [json_name = "defaultValue"];`
`boolean`
`hasExtendee()`
`optional string extendee = 2 [json_name = "extendee"];`
`boolean`
`hasJsonName()`
`optional string json_name = 10 [json_name = "jsonName"];`
`boolean`
`hasLabel()`
`optional .google.protobuf.FieldDescriptorProto.Label label = 4 [json_name = "label"];`
`boolean`
`hasName()`
`optional string name = 1 [json_name = "name"];`
`boolean`
`hasNumber()`
`optional int32 number = 3 [json_name = "number"];`
`boolean`
`hasOneofIndex()`
`optional int32 oneof_index = 9 [json_name = "oneofIndex"];`
`boolean`
`hasOptions()`
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`
`boolean`
`hasProto3Optional()`
`optional bool proto3_optional = 17 [json_name = "proto3Optional"];`
`boolean`
`hasType()`
`optional .google.protobuf.FieldDescriptorProto.Type type = 5 [json_name = "type"];`
`boolean`
`hasTypeName()`
`optional string type_name = 6 [json_name = "typeName"];`
`protected GeneratedMessage.FieldAccessorTable`
`internalGetFieldAccessorTable()`
Get the FieldAccessorTable for this type.
`final boolean`
`isInitialized()`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.
`DescriptorProtos.FieldDescriptorProto.Builder`
`mergeFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)`
Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions.
`DescriptorProtos.FieldDescriptorProto.Builder`
`mergeFrom(DescriptorProtos.FieldDescriptorProto other)`
`DescriptorProtos.FieldDescriptorProto.Builder`
`mergeFrom(Message other)`
Merge `other` into the message being built.
`DescriptorProtos.FieldDescriptorProto.Builder`
`mergeOptions(DescriptorProtos.FieldOptions value)`
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setDefaultValue(String value)`
`optional string default_value = 7 [json_name = "defaultValue"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setDefaultValueBytes(ByteString value)`
`optional string default_value = 7 [json_name = "defaultValue"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setExtendee(String value)`
`optional string extendee = 2 [json_name = "extendee"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setExtendeeBytes(ByteString value)`
`optional string extendee = 2 [json_name = "extendee"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setJsonName(String value)`
`optional string json_name = 10 [json_name = "jsonName"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setJsonNameBytes(ByteString value)`
`optional string json_name = 10 [json_name = "jsonName"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setLabel(DescriptorProtos.FieldDescriptorProto.Label value)`
`optional .google.protobuf.FieldDescriptorProto.Label label = 4 [json_name = "label"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setName(String value)`
`optional string name = 1 [json_name = "name"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setNameBytes(ByteString value)`
`optional string name = 1 [json_name = "name"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setNumber(int value)`
`optional int32 number = 3 [json_name = "number"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setOneofIndex(int value)`
`optional int32 oneof_index = 9 [json_name = "oneofIndex"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setOptions(DescriptorProtos.FieldOptions value)`
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setOptions(DescriptorProtos.FieldOptions.Builder builderForValue)`
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setProto3Optional(boolean value)`
`optional bool proto3_optional = 17 [json_name = "proto3Optional"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setType(DescriptorProtos.FieldDescriptorProto.Type value)`
`optional .google.protobuf.FieldDescriptorProto.Type type = 5 [json_name = "type"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setTypeName(String value)`
`optional string type_name = 6 [json_name = "typeName"];`
`DescriptorProtos.FieldDescriptorProto.Builder`
`setTypeNameBytes(ByteString value)`
`optional string type_name = 6 [json_name = "typeName"];`

### Methods inherited from class com.google.protobuf.GeneratedMessage.Builder

`addRepeatedField, clearField, clearOneof, clone, getAllFields, getField, getFieldBuilder, getOneofFieldDescriptor, getParentForChildren, getRepeatedField, getRepeatedFieldBuilder, getRepeatedFieldCount, getUnknownFields, getUnknownFieldSetBuilder, hasField, hasOneof, internalGetMapField, internalGetMapFieldReflection, internalGetMutableMapField, internalGetMutableMapFieldReflection, isClean, markClean, mergeUnknownFields, mergeUnknownLengthDelimitedField, mergeUnknownVarintField, newBuilderForField, onBuilt, onChanged, parseUnknownField, setField, setRepeatedField, setUnknownFields, setUnknownFieldSetBuilder, setUnknownFieldsProto3`

### Methods inherited from class com.google.protobuf.AbstractMessage.Builder

`findInitializationErrors, getInitializationErrorString, internalMergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, newUninitializedMessageException, toString`

### Methods inherited from class com.google.protobuf.AbstractMessageLite.Builder

`addAll, addAll, mergeDelimitedFrom, mergeDelimitedFrom, mergeFrom, newUninitializedMessageException`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.protobuf.Message.Builder

`mergeDelimitedFrom, mergeDelimitedFrom`

### Methods inherited from interface com.google.protobuf.MessageLite.Builder

`mergeFrom`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`findInitializationErrors, getAllFields, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof`

## Method Details

### getDescriptor

public static final Descriptors.Descriptor getDescriptor()

### internalGetFieldAccessorTable

protected GeneratedMessage.FieldAccessorTable internalGetFieldAccessorTable()
Description copied from class: `GeneratedMessage.Builder`
Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.

Specified by:
  `internalGetFieldAccessorTable` in class `GeneratedMessage.Builder<DescriptorProtos.FieldDescriptorProto.Builder>`

### clear

public DescriptorProtos.FieldDescriptorProto.Builder clear()
Description copied from class: `GeneratedMessage.Builder`
Called by the initialization and clear code paths to allow subclasses to reset any of their builtin fields back to the initial values.

Specified by:
  `clear` in interface `Message.Builder`
Specified by:
  `clear` in interface `MessageLite.Builder`
Overrides:
  `clear` in class `GeneratedMessage.Builder<DescriptorProtos.FieldDescriptorProto.Builder>`

### getDescriptorForType

public Descriptors.Descriptor getDescriptorForType()
Description copied from interface: `Message.Builder`
Get the message's type's descriptor. See `MessageOrBuilder.getDescriptorForType()`.

Specified by:
  `getDescriptorForType` in interface `Message.Builder`
Specified by:
  `getDescriptorForType` in interface `MessageOrBuilder`
Overrides:
  `getDescriptorForType` in class `GeneratedMessage.Builder<DescriptorProtos.FieldDescriptorProto.Builder>`

### getDefaultInstanceForType

public DescriptorProtos.FieldDescriptorProto getDefaultInstanceForType()
Description copied from interface: `MessageLiteOrBuilder`
Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.

Specified by:
  `getDefaultInstanceForType` in interface `MessageLiteOrBuilder`
Specified by:
  `getDefaultInstanceForType` in interface `MessageOrBuilder`

### build

public DescriptorProtos.FieldDescriptorProto build()
Description copied from interface: `MessageLite.Builder`
Constructs the message based on the state of the Builder. Subsequent changes to the Builder will not affect the returned message.

Specified by:
  `build` in interface `Message.Builder`
Specified by:
  `build` in interface `MessageLite.Builder`

### buildPartial

public DescriptorProtos.FieldDescriptorProto buildPartial()
Description copied from interface: `MessageLite.Builder`
Like `MessageLite.Builder.build()`, but does not throw an exception if the message is missing required fields. Instead, a partial message is returned. Subsequent changes to the Builder will not affect the returned message.

Specified by:
  `buildPartial` in interface `Message.Builder`
Specified by:
  `buildPartial` in interface `MessageLite.Builder`

### mergeFrom

public DescriptorProtos.FieldDescriptorProto.Builder mergeFrom(Message other)
Description copied from interface: `Message.Builder`
Merge `other` into the message being built. `other` must have the exact same type as `this` (i.e. `getDescriptorForType() == other.getDescriptorForType()`).

Merging occurs as follows. For each field:
* For singular primitive fields, if the field is set in `other`, then `other`'s value overwrites the value in this message.
* For singular message fields, if the field is set in `other`, it is merged into the corresponding sub-message of this message using the same merging rules.
* For repeated fields, the elements in `other` are concatenated with the elements in this message.
* For oneof groups, if the other message has one of the fields set, the group of this message is cleared and replaced by the field of the other message, so that the oneof constraint is preserved.

This is equivalent to the `Message::MergeFrom` method in C++.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessage.Builder<DescriptorProtos.FieldDescriptorProto.Builder>`

### mergeFrom

public DescriptorProtos.FieldDescriptorProto.Builder mergeFrom(DescriptorProtos.FieldDescriptorProto other)

### isInitialized

public final boolean isInitialized()
Description copied from interface: `MessageLiteOrBuilder`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.

See also: `MessageOrBuilder.getInitializationErrorString()`

Specified by:
  `isInitialized` in interface `MessageLiteOrBuilder`
Overrides:
  `isInitialized` in class `GeneratedMessage.Builder<DescriptorProtos.FieldDescriptorProto.Builder>`

### mergeFrom

public DescriptorProtos.FieldDescriptorProto.Builder mergeFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry) throws IOException
Description copied from interface: `MessageLite.Builder`
Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions. The extensions that you want to be able to parse must be registered in `extensionRegistry`. Extensions not in the registry will be treated as unknown fields.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessage.Builder<DescriptorProtos.FieldDescriptorProto.Builder>`
Throws:
  `IOException` - an I/O error reading from the stream

### hasName

public boolean hasName()
`optional string name = 1 [json_name = "name"];`

Specified by:
  `hasName` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  Whether the name field is set.

### getName

public String getName()
`optional string name = 1 [json_name = "name"];`

Specified by:
  `getName` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The name.

### getNameBytes

public ByteString getNameBytes()
`optional string name = 1 [json_name = "name"];`

Specified by:
  `getNameBytes` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The bytes for name.

### setName

public DescriptorProtos.FieldDescriptorProto.Builder setName(String value)
`optional string name = 1 [json_name = "name"];`

Parameters:
  `value` - The name to set.
Returns:
  This builder for chaining.

### clearName

public DescriptorProtos.FieldDescriptorProto.Builder clearName()
`optional string name = 1 [json_name = "name"];`

Returns:
  This builder for chaining.

### setNameBytes

public DescriptorProtos.FieldDescriptorProto.Builder setNameBytes(ByteString value)
`optional string name = 1 [json_name = "name"];`

Parameters:
  `value` - The bytes for name to set.
Returns:
  This builder for chaining.

### hasNumber

public boolean hasNumber()
`optional int32 number = 3 [json_name = "number"];`

Specified by:
  `hasNumber` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  Whether the number field is set.

### getNumber

public int getNumber()
`optional int32 number = 3 [json_name = "number"];`

Specified by:
  `getNumber` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The number.

### setNumber

public DescriptorProtos.FieldDescriptorProto.Builder setNumber(int value)
`optional int32 number = 3 [json_name = "number"];`

Parameters:
  `value` - The number to set.
Returns:
  This builder for chaining.

### clearNumber

public DescriptorProtos.FieldDescriptorProto.Builder clearNumber()
`optional int32 number = 3 [json_name = "number"];`

Returns:
  This builder for chaining.

### hasLabel

public boolean hasLabel()
`optional .google.protobuf.FieldDescriptorProto.Label label = 4 [json_name = "label"];`

Specified by:
  `hasLabel` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  Whether the label field is set.

### getLabel

public DescriptorProtos.FieldDescriptorProto.Label getLabel()
`optional .google.protobuf.FieldDescriptorProto.Label label = 4 [json_name = "label"];`

Specified by:
  `getLabel` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The label.

### setLabel

public DescriptorProtos.FieldDescriptorProto.Builder setLabel(DescriptorProtos.FieldDescriptorProto.Label value)
`optional .google.protobuf.FieldDescriptorProto.Label label = 4 [json_name = "label"];`

Parameters:
  `value` - The label to set.
Returns:
  This builder for chaining.

### clearLabel

public DescriptorProtos.FieldDescriptorProto.Builder clearLabel()
`optional .google.protobuf.FieldDescriptorProto.Label label = 4 [json_name = "label"];`

Returns:
  This builder for chaining.

### hasType

public boolean hasType()
`optional .google.protobuf.FieldDescriptorProto.Type type = 5 [json_name = "type"];`

Specified by:
  `hasType` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  Whether the type field is set.

### getType

public DescriptorProtos.FieldDescriptorProto.Type getType()
`optional .google.protobuf.FieldDescriptorProto.Type type = 5 [json_name = "type"];`

Specified by:
  `getType` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The type.

### setType

public DescriptorProtos.FieldDescriptorProto.Builder setType(DescriptorProtos.FieldDescriptorProto.Type value)
`optional .google.protobuf.FieldDescriptorProto.Type type = 5 [json_name = "type"];`

Parameters:
  `value` - The type to set.
Returns:
  This builder for chaining.

### clearType

public DescriptorProtos.FieldDescriptorProto.Builder clearType()
`optional .google.protobuf.FieldDescriptorProto.Type type = 5 [json_name = "type"];`

Returns:
  This builder for chaining.

### hasTypeName

public boolean hasTypeName()
`optional string type_name = 6 [json_name = "typeName"];`

Specified by:
  `hasTypeName` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  Whether the typeName field is set.

### getTypeName

public String getTypeName()
`optional string type_name = 6 [json_name = "typeName"];`

Specified by:
  `getTypeName` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The typeName.

### getTypeNameBytes

public ByteString getTypeNameBytes()
`optional string type_name = 6 [json_name = "typeName"];`

Specified by:
  `getTypeNameBytes` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The bytes for typeName.

### setTypeName

public DescriptorProtos.FieldDescriptorProto.Builder setTypeName(String value)
`optional string type_name = 6 [json_name = "typeName"];`

Parameters:
  `value` - The typeName to set.
Returns:
  This builder for chaining.

### clearTypeName

public DescriptorProtos.FieldDescriptorProto.Builder clearTypeName()
`optional string type_name = 6 [json_name = "typeName"];`

Returns:
  This builder for chaining.

### setTypeNameBytes

public DescriptorProtos.FieldDescriptorProto.Builder setTypeNameBytes(ByteString value)
`optional string type_name = 6 [json_name = "typeName"];`

Parameters:
  `value` - The bytes for typeName to set.
Returns:
  This builder for chaining.

### hasExtendee

public boolean hasExtendee()
`optional string extendee = 2 [json_name = "extendee"];`

Specified by:
  `hasExtendee` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  Whether the extendee field is set.

### getExtendee

public String getExtendee()
`optional string extendee = 2 [json_name = "extendee"];`

Specified by:
  `getExtendee` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The extendee.

### getExtendeeBytes

public ByteString getExtendeeBytes()
`optional string extendee = 2 [json_name = "extendee"];`

Specified by:
  `getExtendeeBytes` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The bytes for extendee.

### setExtendee

public DescriptorProtos.FieldDescriptorProto.Builder setExtendee(String value)
`optional string extendee = 2 [json_name = "extendee"];`

Parameters:
  `value` - The extendee to set.
Returns:
  This builder for chaining.

### clearExtendee

public DescriptorProtos.FieldDescriptorProto.Builder clearExtendee()
`optional string extendee = 2 [json_name = "extendee"];`

Returns:
  This builder for chaining.

### setExtendeeBytes

public DescriptorProtos.FieldDescriptorProto.Builder setExtendeeBytes(ByteString value)
`optional string extendee = 2 [json_name = "extendee"];`

Parameters:
  `value` - The bytes for extendee to set.
Returns:
  This builder for chaining.

### hasDefaultValue

public boolean hasDefaultValue()
`optional string default_value = 7 [json_name = "defaultValue"];`

Specified by:
  `hasDefaultValue` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  Whether the defaultValue field is set.

### getDefaultValue

public String getDefaultValue()
`optional string default_value = 7 [json_name = "defaultValue"];`

Specified by:
  `getDefaultValue` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The defaultValue.

### getDefaultValueBytes

public ByteString getDefaultValueBytes()
`optional string default_value = 7 [json_name = "defaultValue"];`

Specified by:
  `getDefaultValueBytes` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The bytes for defaultValue.

### setDefaultValue

public DescriptorProtos.FieldDescriptorProto.Builder setDefaultValue(String value)
`optional string default_value = 7 [json_name = "defaultValue"];`

Parameters:
  `value` - The defaultValue to set.
Returns:
  This builder for chaining.

### clearDefaultValue

public DescriptorProtos.FieldDescriptorProto.Builder clearDefaultValue()
`optional string default_value = 7 [json_name = "defaultValue"];`

Returns:
  This builder for chaining.

### setDefaultValueBytes

public DescriptorProtos.FieldDescriptorProto.Builder setDefaultValueBytes(ByteString value)
`optional string default_value = 7 [json_name = "defaultValue"];`

Parameters:
  `value` - The bytes for defaultValue to set.
Returns:
  This builder for chaining.

### hasOneofIndex

public boolean hasOneofIndex()
`optional int32 oneof_index = 9 [json_name = "oneofIndex"];`

Specified by:
  `hasOneofIndex` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  Whether the oneofIndex field is set.

### getOneofIndex

public int getOneofIndex()
`optional int32 oneof_index = 9 [json_name = "oneofIndex"];`

Specified by:
  `getOneofIndex` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The oneofIndex.

### setOneofIndex

public DescriptorProtos.FieldDescriptorProto.Builder setOneofIndex(int value)
`optional int32 oneof_index = 9 [json_name = "oneofIndex"];`

Parameters:
  `value` - The oneofIndex to set.
Returns:
  This builder for chaining.

### clearOneofIndex

public DescriptorProtos.FieldDescriptorProto.Builder clearOneofIndex()
`optional int32 oneof_index = 9 [json_name = "oneofIndex"];`

Returns:
  This builder for chaining.

### hasJsonName

public boolean hasJsonName()
`optional string json_name = 10 [json_name = "jsonName"];`

Specified by:
  `hasJsonName` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  Whether the jsonName field is set.

### getJsonName

public String getJsonName()
`optional string json_name = 10 [json_name = "jsonName"];`

Specified by:
  `getJsonName` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The jsonName.

### getJsonNameBytes

public ByteString getJsonNameBytes()
`optional string json_name = 10 [json_name = "jsonName"];`

Specified by:
  `getJsonNameBytes` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The bytes for jsonName.

### setJsonName

public DescriptorProtos.FieldDescriptorProto.Builder setJsonName(String value)
`optional string json_name = 10 [json_name = "jsonName"];`

Parameters:
  `value` - The jsonName to set.
Returns:
  This builder for chaining.

### clearJsonName

public DescriptorProtos.FieldDescriptorProto.Builder clearJsonName()
`optional string json_name = 10 [json_name = "jsonName"];`

Returns:
  This builder for chaining.

### setJsonNameBytes

public DescriptorProtos.FieldDescriptorProto.Builder setJsonNameBytes(ByteString value)
`optional string json_name = 10 [json_name = "jsonName"];`

Parameters:
  `value` - The bytes for jsonName to set.
Returns:
  This builder for chaining.

### hasOptions

public boolean hasOptions()
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`

Specified by:
  `hasOptions` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  Whether the options field is set.

### getOptions

public DescriptorProtos.FieldOptions getOptions()
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`

Specified by:
  `getOptions` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The options.

### setOptions

public DescriptorProtos.FieldDescriptorProto.Builder setOptions(DescriptorProtos.FieldOptions value)
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`

### setOptions

public DescriptorProtos.FieldDescriptorProto.Builder setOptions(DescriptorProtos.FieldOptions.Builder builderForValue)
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`

### mergeOptions

public DescriptorProtos.FieldDescriptorProto.Builder mergeOptions(DescriptorProtos.FieldOptions value)
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`

### clearOptions

public DescriptorProtos.FieldDescriptorProto.Builder clearOptions()
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`

### getOptionsBuilder

public DescriptorProtos.FieldOptions.Builder getOptionsBuilder()
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`

### getOptionsOrBuilder

public DescriptorProtos.FieldOptionsOrBuilder getOptionsOrBuilder()
`optional .google.protobuf.FieldOptions options = 8 [json_name = "options"];`

Specified by:
  `getOptionsOrBuilder` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`

### hasProto3Optional

public boolean hasProto3Optional()
`optional bool proto3_optional = 17 [json_name = "proto3Optional"];`

Specified by:
  `hasProto3Optional` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  Whether the proto3Optional field is set.

### getProto3Optional

public boolean getProto3Optional()
`optional bool proto3_optional = 17 [json_name = "proto3Optional"];`

Specified by:
  `getProto3Optional` in interface `DescriptorProtos.FieldDescriptorProtoOrBuilder`
Returns:
  The proto3Optional.

### setProto3Optional

public DescriptorProtos.FieldDescriptorProto.Builder setProto3Optional(boolean value)
`optional bool proto3_optional = 17 [json_name = "proto3Optional"];`

Parameters:
  `value` - The proto3Optional to set.
Returns:
  This builder for chaining.

### clearProto3Optional

public DescriptorProtos.FieldDescriptorProto.Builder clearProto3Optional()
`optional bool proto3_optional = 17 [json_name = "proto3Optional"];`

Returns:
  This builder for chaining.